#!/usr/bin/env bash

# $1 is the name of the package to be installed
# app.install.properties:

# app.to.install=apm
# app.to.install.version=5.0.3
# cli.name=tui-2.1.4.tar.gz
# cucm.ulr=https://192.168.110.81
# scripts.to.be.run=script1 script2 script3

sudo openssl enc -d -aes-256-cbc -in /var/www/product_update/$1 -pass pass:'HtBr6QckqJPk4rpatyUNT594' | tar xz -C /var/www/product_update/

file="/var/www/product_update/app.install.properties"

if [ -f "$file" ]
then
  echo "$file found."

  while IFS='=' read -r key value
  do
    key=$(echo $key | tr '.' '_')
    eval ${key}=\${value}
  done < "$file"

  echo "Product Name= " ${app_to_install}
  echo "Product Version = " ${app_to_install_version}
else
  echo "$file not found."
fi


#validate which product are being installed and look into the config file inside the installer
#TODO validate!!!

# Assuming the /var/www/product_update/ contains:
# update_main.sh,
# application.zip,
# scripts folder,
# cli.tar.gz file

echo "Running cli installation"
sudo sh /home/akkadianuser/scripts/auto_update.sh /var/www/product_update/${cli_name}

sleep 30

if [[ -d /opt/akkadian/ ]]; then
    #TODO: calculate the cucm url
    sudo sh /home/akkadianuser/scripts/aco_update.sh /var/www/product_update/${app_package_name} ${cucm_url}
else
    echo "Running pme installer file name: ${app_package_name}"
    pme_version=$(sh /home/akkadianuser/scripts/get_PME_version.sh)
    sudo sh /home/akkadianuser/scripts/pme_update.sh $pme_version /var/www/product_update/${app_package_name}
fi


#update system by running scripts think in order of the scripts
IFS=$' '
for j in ${scripts_to_be_run}
do
    echo "Running $j"
    sudo sh /var/www/product_update/$j
done

